﻿using UnityEngine;
using System.Collections;

public class enemyManager : MonoBehaviour {
	public bool tagged = false;
	public playerManager scout;
	public sniperManager snipe;
	public bool dead = false;
	public float start;
	public float end;
	public float speed = 5f;
	public RaycastHit hit;

	// Use this for initialization
	void Start () {
		GameObject.Find ("Main Camera").GetComponent<gameManager> ().enemies.Add (this);
		scout = GameObject.Find ("Scout").GetComponent<playerManager> ();
		snipe = GameObject.Find ("SniperSpot").GetComponent<sniperManager> ();
	}

	void Update(){
		if (dead)
			return;
		if (speed > 0) {
			if (this.transform.position.z < Mathf.Max (start, end)) {
				this.rigidbody.velocity = new Vector3 (0, 0, speed);
			} else
				speed *= -1;
		} else if (speed < 0) {
			if(this.transform.position.z > Mathf.Min(start,end)){
				this.rigidbody.velocity = new Vector3(0,0,speed);
			}
			else speed *= -1;
		}
		if (Physics.Raycast (this.transform.position,-this.transform.position + scout.transform.position, out hit)) {
			if(hit.collider.gameObject.tag != "PlayerCont") return;
			print("player dead");
			Application.LoadLevel("_Scene_0");
		}
	}
	
	// Update is called once per frame
	void OnMouseDown () {
		if (scout.enabled) {
			tagged = true;
		} else if (snipe.enabled) {
			this.rigidbody.freezeRotation = false;
			dead = true;
			this.gameObject.GetComponent<TrailRenderer>().enabled = true;
			rigidbody.AddForce(new Vector3(0,0,1000f));
		}
	}
}
